--if true then return end
local StrataTable = {
	WORLD = "BACKGROUND",
	BACKGROUND = "LOW",
	LOW = "MEDIUM",
	MEDIUM = "HIGH",
	HIGH = "DIALOG",
	DIALOG = "FULLSCREEN",
	FULLSCREEN = "FULLSCREEN_DIALOG",
	["FULLSCREEN_DIALOG"] = "TOOLTIP",
	TOOLTIP = "TOOLTIP"
}
local Origicons = {
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_1",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_2",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_3",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_4",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_5",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_6",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_7",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_8",
}

local RegisterAddonMessagePrefix = C_ChatInfo.RegisterAddonMessagePrefix
local SendAddonMessage = C_ChatInfo.SendAddonMessage

--------------------------------------------- Här BöRJAR LIB
local MAJOR,MINOR="PaintBoxThingy-1.0",1
assert(LibStub, MAJOR .. " requires LibStub")
local PaintBoxThingy, oldversion = LibStub:NewLibrary(MAJOR,MINOR)
if not PaintBoxThingy then return end

PaintBoxThingy.Canvases = PaintBoxThingy.Canvases or {}
PaintBoxThingy.Prefixes = PaintBoxThingy.Prefixes or {}
PaintBoxThingy.Texturelist = PaintBoxThingy.Texturelist or Origicons
PaintBoxThingy.SendPool = PaintBoxThingy.SendPool or {}
PaintBoxThingy.SendQueue = PaintBoxThingy.SendQueue or {}

if not(Framepool) then
	Framepool={
		Anchor={},
		Line={
			Unused={},
			Used={}
		},
		Texture={
			Unused={},
			Used={}
		}
	}
end

local sendpool = PaintBoxThingy.SendPool--Make calls shorter.
local SendQueue = PaintBoxThingy.SendQueue
local Canvases=PaintBoxThingy.Canvases
local Texturelist = PaintBoxThingy.Texturelist

local Lastanch, mousex,mousey,active,MaxEr
local LastA={}
local Free,Linetool, Square, Triangle, Circle, Texture = {}, {}, {}, {}, {},{}
local RequestResync, GetLine, SetLine, GetTexture, GetAnchor		--Functions that needs to be made local before the function code
local transferframe,editwait = CreateFrame("frame")

local function GetCanvasPos(Canvas)
	--local parent=Canvas:GetParent()
	--local scale = parent:GetEffectiveScale()/UIParent:GetScale()
	--Canvas.pos.x,Canvas.pos.y = parent:GetLeft()*scale, parent:GetBottom()*scale
	local scale = Canvas:GetEffectiveScale()/UIParent:GetScale()
	Canvas.pos.x, Canvas.pos.y = Canvas:GetLeft()*scale, Canvas:GetBottom()*scale
end


function CursorPosition(scale)
	if scale==false then
		return _G.GetCursorPosition()
	else
		local Scale = UIParent:GetScale()
		local x, y = _G.GetCursorPosition()
		return x/Scale, y/Scale
	end
end

local function Slowshow(Canvas)
	Canvas:SetFrameStrata(StrataTable[Canvas:GetParent():GetFrameStrata()])
	local showpos=Canvas.sp
	--print(showpos)
	local ref=Canvas.ref
	local pool=Framepool.Anchor[ref]
	if showpos+100 > #pool then
		print(#pool)
		for i=showpos, #pool do
			local Anch=pool[i]
			--Anch:SetScale(Canvas:GetEffectiveScale())
			--Anch:Show()
			--Anch:SetPoint("CENTER",Canvas,"BOTTOMLEFT",Anch.x,Anch.y)
			if Anch.EndL then
				Anch.EndL:Show()
			end
		end
		--Rescale(Canvas,nil,true)
		Canvas:SetScript("OnUpdate",nil)
		GetCanvasPos(Canvas)
	else
		for i=showpos, showpos+100 do
			local Anch=pool[i]
			--Anch:SetScale(Canvas:GetEffectiveScale())
			--Anch:SetPoint("CENTER",Canvas,"BOTTOMLEFT",Anch.x,Anch.y)
			--Anch:Show()
			if Anch.EndL then
				Anch.EndL:Show()
			end
		end
		showpos=showpos+100
		Canvas.sp=showpos
	end
end


local function Genum(n,l)
	local t=0
	local o,e
	local o=#n-1
	for l=1,#n do
		e=strbyte(n,l)
		if e>=255 then
			e=e-254
		end
		t=t+(e-1)*(254^(o))
		o=o-1
	end
	return t
end

local function Komprim(text,olof,lima)
	local ne
	local en=""
	if(lima==true)then
		text=text+math.floor((256^olof)/2)
	end
		while true do
		ne=math.fmod(text,254)
		en=string.char(ne+1)..en
		if(text>=254)then
			text=math.floor(text/254)
		else
			break
		end
	end
	if(#en<olof)then
		en=string.rep(string.char(255),(olof-#en))..en
	end
	return en
end

local Painting=true


-----------------Sudda
local function CLEAR(ref)
Senddebug={}
--Getdebug={}
LastA[ref]=nil
	local Canvas=Canvases[ref].Canvas
	Canvas.L=4
	Canvas.AP=0
	local pool = Framepool.Line
	local thispool = pool.Used[ref]
	for i=#thispool, 1,-1 do
		local line=thispool[i]
		line:Hide()
		line.EndP=nil
		line.StartP=nil
		tinsert(pool.Unused,thispool[i])
		tremove(thispool,i)
	end
	pool = Framepool.Anchor
	thispool =  pool[ref]
	for i=#thispool, 1,-1 do
		local anch=thispool[i]
		anch.parent=nil
		anch.EndL=nil
		anch.StartL=nil
		tremove(thispool,i)
	end
	pool = Framepool.Texture
	thispool = pool.Used[ref]
	for i=#thispool, 1 ,-1 do
		local Tex = thispool[i]
		Tex:Hide()
		Tex.StartP=nil
		Tex.EndP = nil
		tinsert(pool.Unused,thispool[i])
		tremove(thispool,i)
	end
	if Canvas.Editor then
		local send = {pre="Clear"..ref,msg="",chan=Canvas.Channel,Extra=Canvas.comextra}
		tinsert(SendQueue[ref],send)
	end
end

local EraseAnchUp, EraseAnchDown--Put them here to not make them globals.

local function EraseLineUp(line)
	EraseAnchUp(line.StartP)
	line.StartP=nil
	line.EndP=nil
	line.c=true
	line:Hide()
end

function EraseAnchUp(anch)
	if not anch then return end
	if anch.EndL and not(anch.LS) then
		EraseLineUp(anch.EndL)
	end
	anch.EndL=nil
	anch.StartL=nil
	anch.c=true
end

local function EraseLineDown(line)
	if line.EndP then
		EraseAnchDown(line.EndP)
	end
	line.startP=nil
	line.Endp=nil
	line.c=true
	line:Hide()
end

function EraseAnchDown(anch)
	if not anch then return end
	if anch.StartL then
		EraseLineDown(anch.StartL)
	end
	anch.StartL=nil
	anch.EndL=nil
	anch.c=true
end

local function Suddar(self)
	if IsMouseButtonDown() and Canvases[self.ref].Canvas.Sudda then
		if IsShiftKeyDown()==false then
			self.c=true
			self:Hide()
			self:SetScript("OnEnter",nil)
			if self.StartP then
				if not(self.StartP.EndL) then
				self.StartP.c=true
				end
			end
			if self.StartP then
				self.StartP.StartL=nil
			end
			if not(self.EndP.StartL) then
				self.EndP.c=true
			end
			self.EndP.EndL=nil
			self.StartP=nil
			self.EndP=nil
		else
			EraseAnchUp(self.StartP)
			self.StartP=nil
			EraseAnchDown(self.EndP)
			self.EndP=nil
			self:Hide()
			self.c=true
		end
	end
end

local function Cleanup(ref)
	local removed = 0
	local pool = Framepool.Anchor
	local Used = pool[ref]
	local tot = #Used
	local text,add,last="A"
	local Send = {}
	local Canvas = Canvases[ref].Canvas
	for i=1, tot do
		i=i-removed
		if Used[i].c==true then
			local Send={}
			Used[i].c=false
			tremove(Used,i)
			Canvas.AP = Canvas.AP-1
			last=text
			add=Komprim(i,3)
			text=text..add
			if strlen(text)>=251 then
				Send.pre="Rem"..ref
				Send.msg=last
				Send.Chan = Canvas.Channel
				Send.Extra=Canvas.comextra
				tinsert(SendQueue[ref],Send)
				text="A"..add
			end
			i=i-1
			removed=removed+1
		end
		if i>=(tot-removed) then break end
	end
	Send.pre="Rem"..ref
	Send.msg=text
	Send.Chan = Canvas.Channel
	Send.Extra=Canvas.comextra
	tinsert(SendQueue[ref],Send)
	text="L"
	removed=0
	pool = Framepool.Line
	Used = pool.Used[ref]
	tot = #Used
	for i=1, tot do
		i=i-removed
		if Used[i].c==true then
			local Send={}
			Used[i].c=false
			tinsert(pool.Unused,Used[i])
			tremove(Used,i)
			last=text
			add=Komprim(i,3)
			text=text..add
			if strlen(text)>=251 then
				Send.pre="Rem"..ref
				Send.msg=last
				Send.Chan=Canvas.Channel
				Send.Extra=Canvas.comextra
				tinsert(SendQueue[ref],Send)
				--SendAddonMessage("Rem"..ref,last,"PARTY")
				text="L"..add
			end
			removed=removed+1
		end
		if i>=(tot-removed) then break end
	end
	local SSend ={}
	SSend.pre="Rem"..ref
	SSend.msg=text
	SSend.Chan=Canvas.Channel
	SSend.Extra=Canvas.comextra
	tinsert(SendQueue[ref],SSend)
	--SendAddonMessage("Rem"..ref,text,"PARTY")
	if Canvas.AP>=0 then Canvas.AP=0 end
end

local function Remremove(msg,ref)
	local list,pool = {}
	local Anch,mypool,line
	for i=2,strlen(msg),3 do
		tinsert(list,Genum(strsub(msg,i,i+2)))
	end
	if strsub(msg,1,1)=="A" then
		pool=Framepool.Anchor
		mypool=pool[ref]
		for i=1,#list do
			Anch=mypool[list[i]]
			if Anch then
				Anch.StartL=nil
				Anch.EndL=nil
				tremove(mypool,list[i])
			end
		end
	elseif strsub(msg,1,1)=="L" then
		pool=Framepool.Line
		mypool=pool.Used[ref]
		for i=1,#list do
			line=mypool[list[i]]
			if line then
				line.StartP=nil
				line.EndP=nil
				line.ref=nil
				line:Hide()
				tinsert(pool.Unused,line)
				tremove(mypool,list[i])
			end
		end
	end
end

---------------------------------------------------------
local function PlaceAnchor(anchor,Canvas,mousex,mousey)
	if mousex~=nil or mousey==nil then
		mousex, mousey = CursorPosition()
	end
	local newx,newy
	local pax,pay = Canvas:GetSize()
	local Cscale = Canvas:GetEffectiveScale()/UIParent:GetScale()
	local x,y = Canvas.pos.x, Canvas.pos.y
	newx, newy = mousex-x,mousey-y
	Canvas.MC.lastx = mousex
	Canvas.MC.lasty = mousey
	newx=newx/Cscale
	newy=newy/Cscale

	if newx < 0 then 	newx = 0 end
	if newx > pax then	newx = pax end
	if newy <0 then 	newy = 0 end
	if newy > pay then	newy = pay	end
	anchor.x=newx
	anchor.y=newy
	--BAM anchor:SetPoint("CENTER",Canvas,"BOTTOMLEFT",newx,newy)--
	--anchor:SetScript("OnUpdate",function() print("yo") anchor:ClearAllPoints()  anchor:SetScript("OnUpdate",nil) end)
end

local function PlaceAnchorAbs(anchor,Canvas,x,y)
	if x<0 then x=0 end
	if y<0 then y=0 end
	local Canx, Cany = Canvas:GetSize()
	if x>Canx then x=Canx end
	if y>Cany then y=Cany end
	anchor.x = x
	anchor.y = y
	--BAM anchor:SetPoint("CENTER",Canvas,"BOTTOMLEFT",x,y)
	--anchor:SetScript("OnUpdate",function() anchor:ClearAllPoints() anchor:SetParent(UIParent) anchor:SetScript("OnUpdate",nil) end)
end


---------------------------------- Kommunikation----------------------------------------------
Senddebug={}
local function CreateString(ref,latest,size)
	if size == 0 or not(size) then size = math.huge end
	local String,nnext,r,b,g,a,z,x,y,zn,cont,add,laststring="",0
	local sendpool = {}
	if not latest  then
		latest = 1
	elseif latest>1 then
		latest = latest+1
		local Hmm=Framepool.Anchor[ref][latest]
		if Hmm.EndL and not(Hmm.LE) and not(Hmm.Te) and not(Hmm.LS) then
			--print("weeoop")
			cont=true
			nnext=1
			String="CS"
		end
	end
	local pool=Framepool.Anchor[ref]
	local tot=0
	for i=latest,#pool do
		--print(i)
		--Senddebug[i]={}
		--local SD=Senddebug[i]
		local SenD = {}
		local anch=pool[i]
		local add,col
		add=""
		col=""
		if (nnext==0 or nnext==2 or nnext==5) and not(anch.Te) then
			r=Komprim(floor(anch.col.r*253),1)
			g=Komprim(floor(anch.col.g*253),1)
			b=Komprim(floor(anch.col.b*253),1)
			a=Komprim(floor(anch.col.a*253),1)
			col=r..g..b..a
			--SD.r=r
			--SD.rraw=floor(anch.col.r)
			--SD.g=g
			--SD.graw=floor(anch.col.g)
			--SD.b=b
			--SD.braw=floor(anch.col.b)
			--SD.a=a
			--SD.araw=floor(anch.col.a)
			--SD.an=anch
		end
		if not(cont) then
			nnext=0
		else
			cont=false
		end
		z=anch.Storlek
		if anch.x<0 then anch.x=0 end
		if anch.y<0 then anch.y=0 end
		x=Komprim(ceil(anch.x),2)
		y=Komprim(ceil(anch.y),2)
		--SD.x=x
		--SD.xraw=ceil(anch.x)
		--SD.y=y
		--SD.yraw=ceil(anch.y)
		if anch.StartL then
			if anch.LE then
				nnext=2
			elseif anch.LS then
				nnext=3
			elseif anch.Te==true then ----It is a texture
				nnext=4--Texture
				z=floor(anch.Rot*1000)
				--print((z*10+nnext))
				col=Komprim(anch.TiD,1)
			else
				nnext=1
			end
		elseif anch.Te==true then
			z=floor(anch.Rot*1000)
			nnext=5
			col=Komprim(anch.TiD,1)
			--print((z*10+nnext))
		end
		zn=Komprim(z*10+nnext,2)
		--SD.zn=zn
		--SD.znraw=z*10+nnext
		--SD.col=col
		local add=add..x..y..zn..col
		laststring=String
		String=String..add
		if String:len()>=size then
			tinsert(sendpool,laststring)
			String=add
		end
	end
	tinsert(sendpool,String)
	return sendpool
end

local function Send(ref,latest)
	local Data = CreateString(ref,latest,251)
	local Channel=Canvases[ref].Canvas.Channel
	local Sendextra = Canvases[ref].Canvas.comextra
	local Output
	for _,info in pairs(Data) do
		Output = {}
		Output.pre="Psend"..ref
		Output.msg=info
		Output.Chan=Channel
		Output.Extra = Sendextra
		tinsert(SendQueue[ref],Output)
	end
end


--Getdebug={}
local function Load(ref,data)
	local length=strlen(data)
	local n=1
	local Anch,Line
	local r,b,g,a,x,y,zn,z,ne,TiD
	local Canvas = Canvases[ref].Canvas
	if data=="Empty" then return end --Empty message to force a sync for newcommers.
	local tot=0
	if strsub(data,1,2)=="CS" then
		--print("COUNTERSTRIKE")
		n=3
		LastA[ref]=Framepool.Anchor[ref][#Framepool.Anchor[ref]]
		--print(strsub(data,2,3))
	end
	while n<length do
		Anch = GetAnchor(ref)
		if Anch==false then n=0 return end
		--Getdebug[#Framepool.Anchor[ref]]={}
		--GD=Getdebug[#Framepool.Anchor[ref]]
		tot=tot+1
		x=Genum(string.sub(data,n,n+1))
		y=Genum(string.sub(data,n+2,n+3))
		zn=Genum(string.sub(data,n+4,n+5))
		--GD.x=x
		--GD.xraw=string.sub(data,n,n+1)
		--GD.y=y
		--GD.yraw=string.sub(data,n+2,n+3)
		--GD.zn=zn
		--GD.znraw=string.sub(data,n+4,n+5)
		--GD.an= Anch
		z=floor(zn/10)
		ne=zn-z*10
		n=n+6
		Anch.x=x
		Anch.y=y
		Anch.Storlek=z
		Anch.c=false
		if ne==4 or ne==5 then
			Anch.TiD=Genum(string.sub(data,n,n))
			Anch.Te=true
			n=n+1
		else
			if not LastA[ref] then
				Canvas.L=Canvas.L+1
				r=Genum(string.sub(data,n,n))/253
				g=Genum(string.sub(data,n+1,n+1))/253
				b=Genum(string.sub(data,n+2,n+2))/253
				a=Genum(string.sub(data,n+3,n+3))/253
				n=n+4
				--GD.r=r
				--GD.rvraw=string.sub(data,n,n)
				--GD.g=g
				--GD.graw=string.sub(data,n+1,n+1)
				--GD.b=b
				--GD.braw=string.sub(data,n+2,n+2)
				--GD.a=a
				--GD.araw=string.sub(data,n+3,n+3)
			else
				r=LastA[ref].col.r
				b=LastA[ref].col.b
				g=LastA[ref].col.g
				a=LastA[ref].col.a
			end
			Anch.col={r=r,b=b,g=g,a=a}
			if LastA[ref] then
				Line=GetLine(ref)
				SetLine(Line,LastA[ref],Anch,Canvas)
			end
		end
		--BAM Anch:SetPoint("CENTER",Canvas,"BOTTOMLEFT",x,y)
		--Anch:ClearAllPoints()
		if ne==1 or ne==4 then
			LastA[ref]=Anch
			if ne==4 then Anch.Rot=z/1000 end
		elseif ne==2 then
			SetLine(GetLine(ref),Anch,Canvas.LS,Canvas)
			LastA[ref]=nil
			Anch.LE = true
		elseif ne==3 then
			Anch.LS = true
			Canvas.LS = Anch
			LastA[ref]=Anch
		elseif ne==5 then
			local Tex = GetTexture(ref)
			Tex:SetParent(Canvas)
			LastA[ref].StartL=Tex
			Tex.StartP=LastA[ref]
			Tex.EndP=Anch
			Anch.EndL=Tex
			Anch.Rot=z/1000
			Tex:SetPoint("TOPLEFT",Canvas,"BOTTOMLEFT",LastA[ref].x,LastA[ref].y)
			Tex:SetPoint("BOTTOMRIGHT",Canvas,"BOTTOMLEFT",Anch.x,Anch.y)
			--print(Texturelist[LastA[ref].TiD])
			Tex.Tex:SetTexture(Texturelist[LastA[ref].TiD])
			Tex.Tex:SetRotation(Anch.Rot)
			Tex:Show()
			LastA[ref]=nil
		else
			LastA[ref]=nil
		end
	end
end

local function Recieve(data,ref)

	local Canvas = Canvases[ref].Canvas
	if Canvas.RStop then return end
	if not Canvas.Insync and not(Canvas.Resync) and not(Canvas.WaitResync) then
		--print("lol")
		RequestResync(ref,Canvas)
		--print("Requested")
		return
	elseif not(Canvas.Insync) and Canvas.WaitResync	then
		--print("Waiting for sync, quit")
		return
	end
	Load(ref,data)
end

-------------------Detta är någon typ av load, osäker på varför det är 2 och vad skildnaden är :/
local recaller=0
local function Recc()
	--print(recaller)
	if (recaller+5)<#sendpool then
		for i=recaller,recaller+5 do
			Recieve(sendpool[i],"asd")
		end
		recaller=recaller+6
		C_Timer.After(0,Recc)
	else
		for i=recaller,#sendpool do
			Recieve(sendpool[i],"asd")
		end
	end
end

local function recall()
	recaller=1
	--print(recaller+5,sendpool)
	if (recaller+5)<#sendpool then
		for i=recaller,recaller+5 do
			Recieve(sendpool[i],"asd",true)
		end
		recaller=recaller+6
		C_Timer.After(0,Recc)
	else
		for i=recaller,#sendpool do
			Recieve(sendpool[i],"asd",true)
		end
	end
end

---------------------------------------------------------
local function CreateTexture(pool)
	local F=CreateFrame("frame",nil)
	F.Tex = F:CreateTexture(nil,"TOOLTIP")
	F.Tex:SetAllPoints()
	tinsert(pool.Unused,F)
end

function GetTexture(ref)--Is local from top
	local pool = Framepool.Texture
	local Canvas = Canvases[ref].Canvas
	if #pool.Unused==0 then
		CreateTexture(pool)
	end
	local Tex = pool.Unused[1]
	--Tex:SetParent(Canvas)
	Tex:ClearAllPoints()
	Tex:SetFrameLevel(Canvases[ref].Canvas.L)
	--Tex.Tex:SetDrawLayer("ARTWORK",Canvases[ref].Canvas.L)
	Tex.Tex:SetRotation(0)
	tinsert(pool.Used[ref],pool.Unused[1])
	tremove(pool.Unused,1)
	return pool.Used[ref][#pool.Used[ref]]
end


local function CreateAnchor(pool)
	local anchor= {}-- BAM CreateFrame("frame",nil)
	--BAM anchor:SetScale(1)
	--BAM anchor:SetSize(2,2)
	anchor.col={}
	tinsert(pool.Unused,anchor)
end

function GetAnchor(ref)
	local Canvas = Canvases[ref].Canvas
	local tot =0
	for k,v in pairs(Framepool.Anchor) do
		tot=tot+#v
	end
	if tot>= 10000 then if not(MaxEr) then print(tot,"Maximum paint done") MaxEr=true end return false end
	MaxEr=false
	local pool=Framepool.Anchor
	tinsert(pool[ref],{col = {}})

	local Anch = pool[ref][#pool[ref]]
	--BAM Anch:SetParent(Canvas)
	--
	Anch.LE = nil
	Anch.LS = nil
	Anch.Te = nil
	Anch.c = false --Flag for clean
	--BAM Anch:ClearAllPoints()
	--BAM Anch:SetFrameStrata(Canvas:GetFrameStrata())
	--BAM Anch:SetFrameLevel(Canvas.L)
	--BAM Anch:SetScale(Canvas:GetEffectiveScale())--/UIParent:GetScale())
	return pool[ref][#pool[ref]]
end

local function CreateLine(pool)
	local  LineFrame = CreateFrame('frame', nil)
	LineFrame:SetSize(5,5)
	LineFrame:SetScale(1)
	LineFrame.Line = LineFrame:CreateLine(nil,'OVERLAY')
	local Line = LineFrame.Line
	Line:SetTexture('interface/buttons/white8x8')
	LineFrame:SetPoint("TOPLEFT",Line,"TOPLEFT",-1,1)
	LineFrame:SetPoint("BOTTOMRIGHT",Line,"BOTTOMRIGHT",1,-1)
	--Line:SetGradientAlpha('HORIZONTAL', 0, 0, 0, 0.5, 1, 0, 0, 0.8)
	tinsert(pool.Unused,LineFrame)
end

function GetLine(ref) ---Is local from top
	local pool=Framepool.Line
	local Canvas = Canvases[ref].Canvas
	if #pool.Unused==0 then
		CreateLine(pool)
	end
	tinsert(pool.Used[ref],pool.Unused[1])
	tremove(pool.Unused,1)
	local line = pool.Used[ref][#pool.Used[ref]]
	--line:SetParent(Canvas)
	line.ref=ref
	line:SetFrameLevel(Canvases[ref].Canvas.L)
	return line
end

function SetLine(Line,StartA,EndA,Canvas) --Is local from top
	local Col=StartA.col
	Line.c=false
	--print(Line,StartA,EndA)
	--BAM Line:SetParent(StartA)
	Line:SetParent(Canvas)--BAM
	Line:SetFrameStrata(Canvas:GetFrameStrata())
	Line:SetFrameLevel(Canvas.L)
	Line.Line:SetStartPoint("BOTTOMLEFT",Canvas,StartA.x,StartA.y)--BAM ,StartA,0,0)
	Line.StartP=StartA
	StartA.StartL=Line
	Line.Line:SetEndPoint("BOTTOMLEFT",Canvas,EndA.x,EndA.y)--BAM ,EndA,0,0)
	Line.EndP=EndA
	EndA.EndL=Line
	Line.Line:SetThickness(StartA.Storlek)
	Line.Line:SetColorTexture(Col.r,Col.g,Col.b,Col.a)
	Line:SetScript("OnEnter",Suddar)
	Line:EnableMouse(false)
	Line:Show()
	Line.Line:Show()
end

local function AbortClean(ref,num)
	local pool = Framepool.Anchor
	local Usepool = pool[ref]
	for i=#Usepool, #Usepool-num,-1 do
		local Anch=Usepool[i]
		Anch:ClearAllPoints()
		tinsert(pool.Unused,Usepool[i])
		tremove(Usepool,i)
	end
	Canvases[ref].Canvas.pause=false
end
---------------------------Texture
do
function Texture.Init(self, button)
	if button~="LeftButton" then return end
	local Canvas = self:GetParent()
	local ref = Canvas.ref
	GetCanvasPos(Canvas)
	Canvas.pause = true
	Canvas.Ta = {}
	self.active=true
	Canvas.L=Canvas.L+1
	for i=1,2 do
		Canvas.Ta[i] = GetAnchor(ref)
		if Canvas.Ta[i]==false then ----Max anchors, Abort
			if i>1 then
				AbortClean(ref,i-2)
			end
			Texture.Quit(self)
			return
		end
		local Anch = Canvas.Ta[i]
		Anch.Te=true
		Anch.TiD=self.TiD
		PlaceAnchor(Anch,Canvas)
	end
	local Anch1 = Canvas.Ta[1]
	local Anch2 = Canvas.Ta[2]
	Anch1.Rot=0
	Anch2.Rot=0
	Anch1.StartL = GetTexture(ref)

	local Tex = Anch1.StartL
	Tex:SetParent(Canvas)
	Tex:SetFrameLevel(Canvas.L)
	Tex:Show()
	Tex.Tex:Show()
	Tex.StartP = Anch1
	Tex.EndP = Anch2
	Anch2.EndL = Anch1.StartL
	Tex.Tex:SetTexture(Texturelist[self.TiD],false)
	Tex:ClearAllPoints()
	Tex:SetPoint("TOPLEFT",Canvas,"BOTTOMLEFT",Anch1.x,Anch1.y)
	Tex:SetPoint("BOTTOMRIGHT",Canvas,"BOTTOMLEFT",Anch2.x,Anch2.y)
	self:SetScript("OnUpdate",Texture.Size)
	self:SetScript("OnMouseDown",Texture.Next)
end

function Texture.Size(self)
	local Canvas = self:GetParent()
	local Anch = Canvas.Ta[2]
	local Tex = Anch.EndL
	PlaceAnchor(Anch,Canvas)
	Tex:SetPoint("BOTTOMRIGHT",Canvas,"BOTTOMLEFT",Anch.x,Anch.y)
end

function Texture.Next(self,button)
	--print("SizeIT")
	if button ~= "LeftButton" then return end
	local Canvas = self:GetParent()
	self.dx , self.dy = Canvas.Ta[1].x-Canvas.Ta[2].x, Canvas.Ta[1].y- Canvas.Ta[2].y
	self.Hyp = sqrt(self.dx^2+self.dy^2)/2
	--print(self.dx,self.dy)
	self:SetScript("OnUpdate",Texture.Place)
	self:SetScript("OnMouseDown",Texture.Quit)
end

function Texture.Place(self)
	local Canvas = self:GetParent()
	local Anch1 = Canvas.Ta[1]
	local Anch2 = Canvas.Ta[2]
	local Tex = Anch2.EndL
	local Oldx, Oldy = Anch2.x, Anch2.y
	PlaceAnchor(Anch2,Canvas)
	Tex:SetPoint("BOTTOMRIGHT",Canvas,"BOTTOMLEFT",Anch2.x,Anch2.y)
	if IsShiftKeyDown()==false then
		local x = Anch2.x+self.dx
		local y = Anch2.y+self.dy
		self.Cx = Anch2.x+self.dx/2
		self.Cy = Anch2.y+self.dy/2
		PlaceAnchorAbs(Anch1,Canvas,x,y)
		Tex:SetPoint("TOPLEFT",Canvas,"BOTTOMLEFT",Anch1.x,Anch1.y)
		--Anch1:SetPoint("CENTER",Canvas,"BOTTOMLEFT",x,y)
		--Anch1.x = x
		--Anch1.y = y
	else
		local Dx, Dy = Anch2.x-self.Cx, Anch2.y-self.Cy
		local Oangle = math.atan2(-self.dy/2,-self.dx/2)
		local Angle = math.atan2(Dy,Dx)-Oangle
		if Angle<0 then
			Angle = 2*math.pi + Angle
		end
		--print(Angle)
		Anch1.Rot=Angle
		Anch2.Rot=Angle
		local Hyp = sqrt(Dx^2+Dy^2)
		Tex.Tex:SetRotation(Angle)
		PlaceAnchorAbs(Anch2,Canvas,Oldx,Oldy)
		Tex:SetPoint("BOTTOMRIGHT",Canvas,"BOTTOMLEFT",Anch2.x,Anch2.y)
		--Anch2:SetPoint("CENTER",Canvas,"BOTTOMLEFT",Oldx,Oldy)
		--Anch2.x=Oldx
		--Anch2.y=Oldy
	end
end

function Texture.Quit(self)
	self.active=false
	self:GetParent().pause=false
	self:SetScript("OnUpdate",nil)
	self:SetScript("OnMouseDown",Texture.Init)
end
end
--------------------------- Line
do
function Linetool.Linedown(self,button)
	if button=="LeftButton" then
		local Canvas = self:GetParent()
		local ref = Canvas.ref
		local Anch=GetAnchor(ref)
		if Anch==false then
			self:GetParent().pause=false
			self.active=false
			return
		end
		Anch.c = false
		Anch.Storlek = Canvas.Thickness
		Anch.col = Canvas.col
		Anch.col.r,Anch.col.g,Anch.col.b, Anch.col.a = Canvas.col.r,Canvas.col.g,Canvas.col.b, Canvas.col.a
		--local mousex,mousey=GetCursorPosition()
		--local scale = UIParent:GetScale()
		--mousex,mousey = mousex/scale, mousey/scale
		PlaceAnchor(Anch,Canvas)--,mousex,mousey)
		local Line = GetLine(ref)
		Line.ref = ref
		SetLine(Line,self.Lastanch,Anch,Canvas)
		self.Lastline = Line
		self.Secondanch = self.Lastanch
		self.Lastanch = Anch
	elseif button=="RightButton" then
		local ref= self:GetParent().ref
		local Anch=self.Lastanch
		Anch.EndL:Hide()
		Anch.EndL.StartP.StartL=nil
		Anch.EndL.Startp=nil
		Anch.EndL.EndP=nil
		Anch.EndL=nil
		--BAM tinsert(Framepool.Line.Unused,Anch.EndL)
		tremove(Framepool.Line.Used[ref],#Framepool.Line.Used[ref]) --detta blev fult
		--BAM Anch:ClearAllPoints()
		--BAM tinsert(Framepool.Anchor.Unused,Anch)
		tremove(Framepool.Anchor[ref],#Framepool.Anchor[ref]) --detta blev fult
		self:SetScript("OnUpdate",nil)
		self:SetScript("OnMouseDown",Linetool.Initline)
		self:GetParent().pause=false
		self.active = false
	end
end



function Linetool.Lineupdater(self)
	local Canvas = self:GetParent()
	PlaceAnchor(self.Lastanch,Canvas)
	SetLine(self.Lastline,self.Secondanch,self.Lastanch,Canvas)

end



function Linetool.Initline(self,button)
	if button~="LeftButton"  then return end
	local Canvas = self:GetParent()
	Canvas.pause=true
	self.active=true
	Canvas.L=Canvas.L+1
	local ref = Canvas.ref
	GetCanvasPos(Canvas)
	local Anch = GetAnchor(ref)------Line start
	if Anch==false then
		Canvas.pause=false
		self.active=false
		return
	end
	Anch.Storlek = Canvas.Thickness
	Anch.col = Canvas.col
	--Anch.col.r,Anch.col.g,Anch.col.b, Anch.col.a = Canvas.col.r,Canvas.col.g,Canvas.col.b, Canvas.col.a
	PlaceAnchor(Anch,Canvas)
	self.Lastanch = Anch
	Anch = GetAnchor(ref)--------Line end
	if Anch==false then
		self.active=false
		Canvas.pause=false
		AbortClean(ref,1)
		return
	end
	Anch.Storlek=Canvas.Thickness
	Anch.col = Canvas.col
	--Anch.col.r,Anch.col.g,Anch.col.b, Anch.col.a = Canvas.col.r,Canvas.col.g,Canvas.col.b, Canvas.col.a-- Can't have a table reference here
	PlaceAnchor(Anch,Canvas)
	local Line = GetLine(ref)
	Line.ref = ref
	SetLine(Line,self.Lastanch,Anch,Canvas)
	self.Secondanch = self.Lastanch
	self.Lastanch = Anch
	self.Lastline = Line
	self:SetScript("OnUpdate",Linetool.Lineupdater)
	self:SetScript("OnMouseDown",Linetool.Linedown)
end
end
-------------------Free hand------------------------------------------
do

function Free.Leave(self)
	if self.active==true then
		Free.Quit(self)
	end
end
function Free.Theupdate(self)
	local Canvas = self:GetParent()
	local ref = self:GetParent().ref
	local mousex,mousey=CursorPosition()
	if sqrt(abs(mousex-self.lastx)^2 + abs(mousey-self.lasty)^2) <2 then return end
	local Anch,F
	Anch=GetAnchor(ref)
	if Anch==false then
		Free.Quit(self)
		return
	end
	Anch.Storlek = Canvas.Thickness
	local Col,LCol = Anch.col, self.Lastanch.col
	Col.r,Col.g,Col.b, Col.a = LCol.r,LCol.g,LCol.b,LCol.a
	PlaceAnchor(Anch,Canvas,mousex,mousey)
	F = GetLine(ref)
	--F.ref = ref
	SetLine(F,self.Lastanch,Anch,Canvas)
	self.Lastanch = Anch
end

function Free.Quit(self)
	self.active=false
	self.lastx=0
	self.lasty=0
	Free.Theupdate(self)
	self:SetScript("OnUpdate",nil)
	self:SetScript("OnLeave",nil)
	self:SetScript("OnMouseUp",nil)
end

function Free.Release(self,button)
	if button~="LeftButton" then return end
	if self.active==true then
		Free.Quit(self)
	end
end

function Free.Initpaint(self,button)
	if button~="LeftButton" then return end
	local Canvas = self:GetParent()
	local ref=Canvas.ref
	GetCanvasPos(Canvas)
	self.active=true
	local Anch = GetAnchor(ref)
	if Anch==false then
		Free.Quit()
		return
	end
	Canvas.L=Canvas.L+1
	Anch.Storlek=Canvas.Thickness
	Anch.col = Canvas.col
	--Anch.col.r,Anch.col.g,Anch.col.b, Anch.col.a = Canvas.col.r,Canvas.col.g,Canvas.col.b, Canvas.col.a
	self.lastx=0
	self.lasty=0
	PlaceAnchor(Anch,Canvas)
	self.Lastanch=Anch
	self:SetScript("OnUpdate",Free.Theupdate)
	self:SetScript("OnLeave",Free.Leave)
	self:SetScript("OnMouseUp",Free.Release)
end
--
end
---------------------------Circle
do
function Circle.Init(self,button)
	if button~="LeftButton" then return end
	local Res = 20
	local Canvas = self:GetParent()
	Canvas.pause = true
	self.active = true
	Canvas.Cir = {}
	Canvas.L=Canvas.L+1
	local ref = Canvas.ref
	GetCanvasPos(Canvas)
	for i=1, Res do --25
		Canvas.Cir[i] = GetAnchor(ref)
		if Canvas.Cir[i]==false then
			if i>1 then
				--print(i)
				AbortClean(ref,i-2)
			end
			Circle.Final(self)
			return
		end
		local Anch = Canvas.Cir[i]
		Anch.Storlek = Canvas.Thickness
		Anch.col = Canvas.col
		--Anch.col.r,Anch.col.g,Anch.col.b, Anch.col.a = Canvas.col.r,Canvas.col.g,Canvas.col.b, Canvas.col.a
		PlaceAnchor(Anch,Canvas)
		if i==1 then
			Anch.LS = true
		elseif i==Res then
			Anch.LE = true
		end
	end
	for i=1, Res do
		local Line = GetLine(ref)
		if i==Res then
			SetLine(Line,Canvas.Cir[i],Canvas.Cir[1],Canvas)
		else
			SetLine(Line,Canvas.Cir[i],Canvas.Cir[i+1],Canvas)
		end
	end
	Canvas.Cir.x = Canvas.Cir[1].x
	Canvas.Cir.y = Canvas.Cir[1].y
	self:SetScript("OnUpdate",Circle.Update)
	self:SetScript("OnMouseUp",Circle.Final)
end

function Circle.Update(self)
	local Res = 20
	local Canvas = self:GetParent()
	PlaceAnchor(Canvas.Cir[2],Canvas)
	local Midx, Midy = Canvas.Cir.x, Canvas.Cir.y
	local Hyp = sqrt((Canvas.Cir[2].x-Midx)^2+(Canvas.Cir[2].y-Midy)^2)
	local step=360/Res
	for i=1,Res do
		local x = Midx+cos(step*i)*Hyp
		local y = Midy+sin(step*i)*Hyp
		PlaceAnchorAbs(Canvas.Cir[i],Canvas,x,y)
		--Canvas.Cir[i]:SetPoint("Center",Canvas,"BOTTOMLEFT",x,y)
		--Canvas.Cir[i].x = x
		--Canvas.Cir[i].y = y
		if i==Res then
			SetLine(Canvas.Cir[i-1].StartL,Canvas.Cir[i-1],Canvas.Cir[i],Canvas)
			SetLine(Canvas.Cir[i].StartL,Canvas.Cir[i],Canvas.Cir[1],Canvas)
		elseif i >= 2 then
			SetLine(Canvas.Cir[i-1].StartL,Canvas.Cir[i-1],Canvas.Cir[i],Canvas)
		end
	end
end

function Circle.Final(self)
	self.active=false
	self:GetParent().pause = false
	self:SetScript("OnUpdate",nil)
	self:SetScript("OnMouseUp",nil)
end

end
-------------------Square-----------------------------------
do
function Square.Init(self,button,extra)
	if button~="LeftButton" then return end
	local Canvas,n = self:GetParent()
	Canvas.pause = true
	self.active = true
	Canvas.Sq = {}
	Canvas.L=Canvas.L+1
	local ref= Canvas.ref
	GetCanvasPos(Canvas)
	if IsShiftKeyDown() then n=6 else n=4 end
	for i=1,n do
		Canvas.Sq[i] = GetAnchor(ref)
		if Canvas.Sq[i]==false then
			if i>1 then
				AbortClean(ref,i-2)
			end
			Square.Final(self)
			return
		end
		local Anch = Canvas.Sq[i]
		Anch.Storlek = Canvas.Thickness
		Anch.col = Canvas.col
		--Anch.col.r,Anch.col.g,Anch.col.b, Anch.col.a = Canvas.col.r,Canvas.col.g,Canvas.col.b, Canvas.col.a
		PlaceAnchor(Anch,Canvas)
		--local Line = GetLine(ref)
		--Line.ref = ref
		if i>=2 and i<5 or i==6 then
			local Line = GetLine(ref)
			SetLine(Line,Canvas.Sq[i-1],Anch,Canvas)
			if i==4 then
				Anch.LE = true
				Line = GetLine(ref)
				SetLine(Line,Anch,Canvas.Sq[1],Canvas)
			end
		elseif i==1 then
			Anch.LS = true
		end
	end
	self:SetScript("OnUpdate",Square.Update)
	self:SetScript("OnMouseUp",Square.Final)
end

function Square.Update(self)
	local Canvas = self:GetParent()
	--local mousex, mousey = CursorPosition()
	PlaceAnchor(Canvas.Sq[3],Canvas)--,mousex, mousey)
	local dx, dy = Canvas.Sq[3].x - Canvas.Sq[1].x, Canvas.Sq[3].y - Canvas.Sq[1].y
	if not (IsControlKeyDown()) then
		self.err=false
		self.rot=false
		local x= Canvas.Sq[1].x
		local y= Canvas.Sq[1].y+dy
		Canvas.SqZ ={x=dx,y=dy}
		PlaceAnchorAbs(Canvas.Sq[2],Canvas,x,y)
		--Canvas.Sq[2]:SetPoint("CENTER",Canvas,"BOTTOMLEFT",x,y)
		--Canvas.Sq[2].x = x
		--Canvas.Sq[2].y = y
		if Canvas.Sq[5] then
			PlaceAnchorAbs(Canvas.Sq[5],Canvas,x,y-dy/2)
			--Canvas.Sq[5]:SetPoint("CENTER",Canvas,"BOTTOMLEFT",x,y-dy/2)
			--Canvas.Sq[5].x = x
			--Canvas.Sq[5].y = y-dy/2
			Canvas.Sq[5].Storlek = ceil(abs(dy*UIParent:GetScale()))
		end
		x = Canvas.Sq[3].x
		y = Canvas.Sq[3].y-dy
		PlaceAnchorAbs(Canvas.Sq[4],Canvas,x,y)
		--Canvas.Sq[4]:SetPoint("Center",Canvas,"BOTTOMLEFT",x,y)
		--Canvas.Sq[4].x = x
		--Canvas.Sq[4].y = y
		if Canvas.Sq[6] then
			PlaceAnchorAbs(Canvas.Sq[6],Canvas,x,y+dy/2)
			--Canvas.Sq[6]:SetPoint("CENTER",Canvas,"BOTTOMLEFT",x,y+dy/2)
			--Canvas.Sq[6].x = x
			--Canvas.Sq[6].y = y+dy/2
			Canvas.Sq[6].EndL.Line:SetThickness(ceil(abs(dy*UIParent:GetScale())))
			Canvas.Sq[6].Storlek = Canvas.Sq[5].Storlek
		end
		for i=1, #Canvas.Sq do
			if i==6 then break end
			local Line = Canvas.Sq[i].StartL
			SetLine(Line,Line.StartP,Line.EndP,Canvas)
		end
	else
		if not(Canvas.SqZ) then
			if not self.err then
				print("Please release control to create the square") self.err=true
			end
			return
		end
		local angle = atan2(dy,dx)
		if not(self.rot) then
			self.rot=true
			if angle>0 then
				self.pos=true
			else
				self.pos=false
			end
		end
		local Sizex, Sizey = Canvas.SqZ.x, Canvas.SqZ.y
		local hyp = sqrt(Sizex^2+Sizey^2)
		local x1,x2,x3,x4,y1,y2,y3,y4
		x1 = Canvas.Sq[1].x
		y1 = Canvas.Sq[1].y
		x3 = x1+cos(angle)*hyp
		y3 = y1+sin(angle)*hyp
		local angle2 = acos(Sizex/hyp)
		if self.pos then
			x2 = x1+cos(angle-angle2)*Sizex
			y2 = y1+sin(angle-angle2)*Sizex
		else
			x2 = x1+cos(angle+angle2)*Sizex
			y2 = y1+sin(angle+angle2)*Sizex
		end
		local angle3
		if self.pos then
			angle3 = angle-angle2+90
		else
			angle3 = angle+angle2+90
		end
		x4 = x1+cos(angle3)*Sizey
		y4 = y1+sin(angle3)*Sizey
		PlaceAnchorAbs(Canvas.Sq[2],Canvas,x2,y2)
		--Canvas.Sq[2]:SetPoint("CENTER",Canvas,"BOTTOMLEFT",x2,y2)
		--Canvas.Sq[2].x = x2
		--Canvas.Sq[2].y = y2
		PlaceAnchorAbs(Canvas.Sq[3],Canvas,x3,y3)
		--Canvas.Sq[3]:SetPoint("CENTER",Canvas,"BOTTOMLEFT",x3,y3)
		--Canvas.Sq[3].x = x3
		--Canvas.Sq[3].y = y3
		PlaceAnchorAbs(Canvas.Sq[4],Canvas,x4,y4)
		--Canvas.Sq[4]:SetPoint("CENTER",Canvas,"BOTTOMLEFT",x4,y4)
		--Canvas.Sq[4].x = x4
		--Canvas.Sq[4].y = y4
		if Canvas.Sq[5] then
			local x5,x6,y5,y6,angle4
				if self.pos then
				angle4=90+angle-angle2
			else
				angle4 = angle+angle2+90
			end
			x5 = x3-cos(angle4)*Sizey/2
			y5 = y3-sin(angle4)*Sizey/2
			PlaceAnchorAbs(Canvas.Sq[5],Canvas,x5,y5)
			--Canvas.Sq[5]:SetPoint("CENTER",Canvas,"BOTTOMLEFT",x5,y5)
			--Canvas.Sq[5].x = x5
			--Canvas.Sq[5].y = y5
			x6 = x1+cos(angle4)*Sizey/2
			y6 = y1+sin(angle4)*Sizey/2
			PlaceAnchorAbs(Canvas.Sq[6],Canvas,x6,y6)
			--Canvas.Sq[6]:SetPoint("CENTER",Canvas,"BOTTOMLEFT",x6,y6)
			--Canvas.Sq[6].x = x6
			--Canvas.Sq[6].y = y6
		end
		for i=1, #Canvas.Sq do
			if i==6 then break end
			local Line = Canvas.Sq[i].StartL
			SetLine(Line,Line.StartP,Line.EndP,Canvas)
		end
	end
end

function Square.Final(self)
	local Canvas=self:GetParent()
	self.active = false
	Canvas.pause = false
	Canvas.SqZ=nil
	self:SetScript("OnUpdate",nil)
	self:SetScript("OnMouseUp",nil)
end
end
---------------------------------Triangle----------------------
do
function Triangle.Init(self,button)
	if button~="LeftButton"  then return end
	local Canvas,n = self:GetParent()
	Canvas.pause = true
	self.active = true
	Canvas.Tr = {}
	Canvas.L=Canvas.L+1
	local ref= Canvas.ref
	GetCanvasPos(Canvas)
	for i=1,3 do
		Canvas.Tr[i] = GetAnchor(ref)
		if Canvas.Tr[i]==false then
			if i>1 then
				AbortClean(ref,i-2)
			end
			Triangle.Quit(self)
			return
		end
		local Anch = Canvas.Tr[i]
		Anch.Storlek = Canvas.Thickness
		Anch.col = Canvas.col
		--Anch.col.r,Anch.col.g,Anch.col.b, Anch.col.a = Canvas.col.r,Canvas.col.g,Canvas.col.b, Canvas.col.a
		PlaceAnchor(Anch,Canvas)
		if i==1 then

			Anch.LS = true
		end
		if i>=2 then
			local Line = GetLine(ref)
			SetLine(Line,Canvas.Tr[i-1],Anch,Canvas)
			if i==3 then
				Anch.LE = true
				Line = GetLine(ref)
				SetLine(Line,Anch,Canvas.Tr[1],Canvas)
			end
		end
	end
	if IsShiftKeyDown() then
		self:SetScript("OnMouseDown",nil)
		self:SetScript("OnMouseUp",Triangle.Quit)
		self:SetScript("OnUpdate",Triangle.SidUpdate)
	else
		self.pos=2
		self:SetScript("OnMouseDown",Triangle.Next)
		self:SetScript("OnUpdate",Triangle.FreeUpdate)
	end
end

function Triangle.Next(self,button)
	if button=="RightButton" then
		Triangle.Quit(self)
	elseif button~="LeftButton" then
		return
	end
	if self.pos==3 then
		self.pos=1
	else
		self.pos=self.pos+1
	end
end

function Triangle.Quit(self)
	self:SetScript("OnMouseDown",Triangle.Init)
	self:SetScript("OnMouseUp",nil)
	self:SetScript("OnUpdate",nil)
	self:GetParent().pause=false
	self.active = false
end


function Triangle.SidUpdate(self)
	local Canvas = self:GetParent()
	PlaceAnchor(Canvas.Tr[3],Canvas)
	local dx, dy = Canvas.Tr[3].x-Canvas.Tr[1].x, Canvas.Tr[3].y-Canvas.Tr[1].y
	local Hyp = sqrt(dx^2+dy^2)
	local angle = math.atan2(dy,dx)
	local x = Canvas.Tr[1].x+math.cos(math.pi/3+angle)*Hyp
	local y = Canvas.Tr[1].y+math.sin(math.pi/3+angle)*Hyp
	PlaceAnchorAbs(Canvas.Tr[2],Canvas,x,y)
	for i=1, 3 do
		local Line = Canvas.Tr[i].StartL
		SetLine(Line,Line.StartP,Line.EndP,Canvas)
	end
	--Canvas.Tr[2]:SetPoint("CENTER",Canvas,"BOTTOMLEFT",x,y)
	--Canvas.Tr[2].x=x
	--Canvas.Tr[2].y=y
end

function Triangle.FreeUpdate(self)
	local Canvas = self:GetParent()
	PlaceAnchor(Canvas.Tr[self.pos],Canvas,mousex, mousey)
	for i=1, 3 do
		local Line = Canvas.Tr[i].StartL
		SetLine(Line,Line.StartP,Line.EndP,Canvas)
	end
end
end--do
------------------------------------------------------------

local function Ticker(Canvas,ref,Click)
	if not Canvas then Canvas = Canvases[ref].Canvas end
	if Canvas.pause==true then return end
	local num=#Framepool.Anchor[ref]
	if num>Canvas.AP then
		--print("send",num)
		if Canvas.AP==0 then Canvas.AP=1 end
		Send(ref,Canvas.AP)
		Canvas.AP=#Framepool.Anchor[ref]
	elseif num==Canvas.AP and Click then

		local Send={pre="Psend"..ref,msg="Empty",Chan=Canvas.Channel,Extra=Canvas.comextra}
		tinsert(SendQueue[ref],Send)
	end
end

function RequestResync(ref)
	CLEAR(ref)
	local prefix = "Edit"..ref
	local msg = "NeedResync"
	local Canvas=Canvases[ref].Canvas
	Canvas.Insync=false
	Canvas.WaitResync=true
	SendAddonMessage(prefix,msg,Canvases[ref].Canvas.Channel)
end




local function MoveHide(ref)--TODO add a throttlethingy here
	for i=1,#Framepool.Line.Used[ref] do
		Framepool.Line.Used[ref][i]:Hide()
	end
	for i=1,#Framepool.Texture.Used[ref] do
		--Framepool.Texture.Used[ref][i]:Hide()
	end
end


local function Onemode(Canvas)
	local MC=Canvas.MC
	if MC.Drawing then
		PaintBoxThingy:Draw(Canvas.ref)
	elseif MC.DrawL then
		PaintBoxThingy:DrawLine(Canvas.ref)
	elseif Canvas.Sudda then
		PaintBoxThingy:Eraser(Canvas.ref)
	elseif MC.DrawSq then
		PaintBoxThingy:DrawSquare(Canvas.ref)
	elseif MC.DrawTr then
		PaintBoxThingy:DrawTriangle(Canvas.ref)
	elseif MC.DrawC then
		PaintBoxThingy:DrawCircle(Canvas.ref)
	elseif MC.PT then
		PaintBoxThingy:PlaceTexture(Canvas.ref)
	end
end

local function EditState(msg,ref)
	local Canvas=Canvases[ref].Canvas
	if msg=="Resync start" then
		if Canvas.WaitResync then
			Canvas.Resync=true
			Canvas.WaitResync=false
		elseif not Canvas.Resync then
			Canvas.RStop=true
		end
	elseif msg=="Resync done" then
		Canvas.Insync=true
		Canvas.RStop=false
		Canvas.Resync=false
	elseif msg=="Forced Resync" then
		CLEAR(ref)
		Canvas.Insync=false
		Canvas.Resync=true
	elseif msg=="NeedResync" and Canvas.Editor then
		local send={pre="Edit"..ref,msg="Resync start",Chan=Canvas.Channel,Extra=Canvas.comextra }
		tinsert(SendQueue[ref],send)
		Send(ref)
		send={pre="Edit"..ref,msg="Resync done",Chan=Canvas.Channel,Extra=Canvas.comextra}
		tinsert(SendQueue[ref],send)
		local send={pre="Edit"..ref,msg="Resync done",Chan=Canvas.Channel,Extra=Canvas.comextra}
		tinsert(SendQueue,send)
	elseif strfind(msg,"Gief editor") then
		--print("gief")
		transferframe.ref=ref
		transferframe.frame=Canvas
		transferframe.to=strsub(msg,13)
		transferframe:SetScript("OnUpdate",function()
			if transferframe.frame.MC.active==false then
				--print("spam")
				--if not(Canvases[ref].ticker) then
					--Ticker(transferframe.frame,transferframe.ref)
				--end
				PaintBoxThingy:ContSend(ref,false)
				Canvas:tick()
				Canvas.Callback(ref,"Editor",false)
				transferframe.frame.Editor=false
				Onemode(transferframe.frame)
				local send = {pre="Edit"..transferframe.ref,msg="Editor Give "..transferframe.to,chan=transferframe.frame.Channel,Extra=transferframe.frame.comextra}
				tinsert(SendQueue[transferframe.ref],send)
				transferframe:SetScript("OnUpdate",nil)


			end
		end)
	elseif strfind(msg,"Editor Give") then
		if strsub(msg,13)==UnitName("player") and editwait then
			Canvases[ref].Canvas.Editor=true
			Canvas.Callback(ref,"Editor",true)
			Canvas.AP=#Framepool.Anchor[ref]
		end
	end
end

local Comm = CreateFrame("frame")



local function handler(self,event,prefix,msg,channel,sender)
	if string.find(sender,UnitName("player")) then
		if strfind(msg,"Editor Give") then   ----Abort the sending when the
			PaintBoxThingy:ContSend(PaintBoxThingy.Prefixes[prefix],false)--queue is empty
		end ---in transfers
		return
	end
	local ref= PaintBoxThingy.Prefixes[prefix]
	if ref then
		if strfind(prefix,"Psend") then
			Recieve(msg,ref)
		elseif strfind(prefix,"Rem") then
			Remremove(msg,ref)
		elseif strfind(prefix,"Clear") then
			CLEAR(ref)
		elseif strfind(prefix,"Edit") then
			EditState(msg,ref)
		end
	end
end

local function Sender()
	for ref,v in pairs(SendQueue) do
		local A = v[1]
		if A then
			--print(A.pre,A.msg,A.Chan,A.Extra)
			SendAddonMessage(A.pre,A.msg,A.Chan,A.Extra)
			tremove(v,1)
		end
	end
end

Comm:RegisterEvent("CHAT_MSG_ADDON")
Comm:SetScript("OnEvent",handler)
C_Timer.NewTicker(0.05,Sender)



----------------------- Öppna funktioner-----------------------


function PaintBoxThingy:Init(ref,parentFrame,callback,Draggers,top,down,left,right)

	local Prefix="Psend"..ref
	RegisterAddonMessagePrefix(Prefix)
	PaintBoxThingy.Prefixes[Prefix]=ref

	Prefix="Rem"..ref
	RegisterAddonMessagePrefix(Prefix)
	PaintBoxThingy.Prefixes[Prefix]=ref

	Prefix="Clear"..ref
	RegisterAddonMessagePrefix(Prefix)
	PaintBoxThingy.Prefixes[Prefix]=ref

	Prefix="Edit"..ref
	RegisterAddonMessagePrefix(Prefix)
	PaintBoxThingy.Prefixes[Prefix]=ref

	Prefix="Num"..ref
	RegisterAddonMessagePrefix(Prefix)
	PaintBoxThingy.Prefixes[Prefix]=ref

	Framepool.Anchor[ref]={}
	Framepool.Line.Used[ref]={}
	Framepool.Texture.Used[ref]={}
	SendQueue[ref] = {}
	local Canvas = CreateFrame("frame","$parentCanvas",parentFrame)
	if top or down or left or right then
		top = top or 0
		down = down or 0
		left = left or 0
		right = right or 0
		Canvas:SetPoint("TOPLEFT",parentFrame,"TOPLEFT",left,top)
		Canvas:SetPoint("BOTTOMRIGHT",parentFrame,"BOTTOMRIGHT",right,down)
	else
		Canvas:SetAllPoints()
	end
	Canvas:SetFlattensRenderLayers(true)
	Canvas.Callback=callback
	Canvas:SetFrameStrata(StrataTable[parentFrame:GetFrameStrata()])
	function Canvas:tick() Ticker(Canvas,ref) end
	Canvas:SetFrameLevel(3)
	Canvas.ref=ref
	Canvas.col={r=1,g=1,b=1,a=1}
	Canvas.AP=0
	Canvas.L=4
	Canvas.Thickness=2
	Canvas.pos={}
	--Canvas:SetScript("OnHide",function() MoveHide(ref) end) --TODO Throttles etc
	--Canvas:SetScript("OnShow",function() Canvas.sp=1 Canvas:SetScript("OnUpdate", Slowshow) end) --TODO Throttles etc
	Canvas:SetScript("OnUpdate",CanvasOnUpdate)
	Canvas.MC = CreateFrame("frame","$parentMc",Canvas)--Mouse capture
	Canvas.MC.lastx = 0
	Canvas.MC.lastyy = 0
	Canvas.MC:SetAllPoints()
	Canvas.MC:SetScript("OnMouseDown",function() end)
	Canvas.MC:SetScript("OnMouseDown",nil)
	Canvas.MC:SetFrameLevel(9998)
	Canvas.MC.active=false
	Canvas.MC:EnableMouse(false)
	Canvases[ref]={}
	Canvases[ref].Canvas=Canvas
	if Draggers then
		for i=1, #Draggers do
			--Draggers[i]:HookScript("OnDragStart",function() MoveHide(ref) end)--TODO Throttles etc
			--Draggers[i]:HookScript("OnDragStop",function() Canvas.sp=1 Canvas:SetScript("OnUpdate",Slowshow) end) --TODO Throttles etc
		end
	end
	return ref
end

function PaintBoxThingy:ContSend(ref,state)
	local Canvas=Canvases[ref].Canvas
	if not Canvas.Editor then state= false end
	Canvas.Callback(ref,"ContSend",state)
	Canvas.pause=false
	if state==true then
		--Canvas.AP=#Framepool.Anchor[ref]
		Canvases[ref].ticker = C_Timer.NewTicker(0.5,Canvas.tick)
	else
		if Canvases[ref].ticker then
			Canvases[ref].ticker:Cancel()
			Canvases[ref].ticket=nil
		end
	end
end

function PaintBoxThingy:Send(ref)
	Ticker(nil,ref,true)
end

function PaintBoxThingy:Draw(ref)
	local Canvas = Canvases[ref].Canvas
	if Canvas.MC.Drawing or not(Canvas.Editor) then
		Canvas.Callback(ref,"Draw",false)
		Canvas.MC.Drawing = false
		Canvas.MC:EnableMouse(false)
		Canvas.MC:SetScript("OnMouseDown",nil)
	else
		Onemode(Canvas)
		Canvas.Callback(ref,"Draw",true)
		Canvas.MC:EnableMouse(true)
		Canvas.MC.Drawing = true
		Canvas.MC:SetScript("OnMouseDown",Free.Initpaint)
	end
end

function PaintBoxThingy:DrawLine(ref)
	local Canvas = Canvases[ref].Canvas
	if Canvas.MC.DrawL or not(Canvas.Editor) then
		Canvas.Callback(ref,"Line",false)
		Canvas.MC.DrawL = false
		Canvas.MC:EnableMouse(false)
		Canvas.MC:SetScript("OnMouseDown",nil)
	else
		Onemode(Canvas)
		Canvas.Callback(ref,"Line",true)
		Canvas.MC:EnableMouse(true)
		Canvas.MC.DrawL=true
		Canvas.MC:SetScript("OnMouseDown",Linetool.Initline)
	end
end

function PaintBoxThingy:DrawSquare(ref)
	local Canvas = Canvases[ref].Canvas
	if Canvas.MC.DrawSq or not(Canvas.Editor) then
		Canvas.Callback(ref,"Square",false)
		Canvas.MC.DrawSq=false
		Canvas.MC:EnableMouse(false)
		Canvas.MC:SetScript("OnMouseDown",nil)
	else
		Onemode(Canvas)
		Canvas.Callback(ref,"Square",true)
		Canvas.MC:EnableMouse(true)
		Canvas.MC.DrawSq=true
		Canvas.MC:SetScript("OnMouseDown",Square.Init)
	end
end

function PaintBoxThingy:DrawTriangle(ref)
	local Canvas = Canvases[ref].Canvas
	if Canvas.MC.DrawTr or not(Canvas.Editor) then
		Canvas.Callback(ref,"Triangle",false)
		Canvas.MC.DrawTr=false
		Canvas.MC:EnableMouse(false)
		Canvas.MC:SetScript("OnMouseDown",nil)
	else
		Onemode(Canvas)
		Canvas.Callback(ref,"Triangle",true)
		Canvas.MC:EnableMouse(true)
		Canvas.MC.DrawTr=true
		Canvas.MC:SetScript("OnMouseDown",Triangle.Init)
	end
end

function PaintBoxThingy:PlaceTexture(ref,textureid)
	local Canvas = Canvases[ref].Canvas
	if Canvas.MC.PT or not(Canvas.Editor) then
		Canvas.Callback(ref,"Texture",false)
		Canvas.MC.PT=false
		Canvas.MC:EnableMouse(false)
		Canvas.MC:SetScript("OnMouseDown",nil)
	else
		Onemode(Canvas)
		Canvas.Callback(ref,"Texture",true)
		Canvas.MC:EnableMouse(true)
		Canvas.MC.PT=true
		Canvas.MC.TiD=textureid
		Canvas.MC:SetScript("OnMouseDown",Texture.Init)
	end
end

function PaintBoxThingy:DrawCircle(ref)
	local Canvas = Canvases[ref].Canvas
	if Canvas.MC.DrawC or not(Canvas.Editor) then
		Canvas.Callback(ref,"Circle",false)
		Canvas.MC.DrawC=false
		Canvas.MC:EnableMouse(false)
		Canvas.MC:SetScript("OnMouseDown",nil)
	else
		Onemode(Canvas)
		Canvas.Callback(ref,"Circle",true)
		Canvas.MC:EnableMouse(true)
		Canvas.MC.DrawC=true
		Canvas.MC:SetScript("OnMouseDown",Circle.Init)
	end
end

function PaintBoxThingy:Eraser(ref)
	local Pool = Framepool.Line.Used[ref]
	local Canvas = Canvases[ref].Canvas
	if Canvas.Sudda or not(Canvas.Editor) then
		for i=1,#Pool do
			Pool[i]:EnableMouse(false)
		end
		Canvas.MC:EnableMouse(false)
		Canvas.Sudda=false
		Cleanup(ref)
		Canvas.Callback(ref,"Eraser",false)
		Canvas.MC:SetFrameLevel(9998)
	else
		Onemode(Canvas)
		for i=1,#Pool do
			Pool[i]:EnableMouse(true)
		end
		Canvas.MC:EnableMouse(true)
		Canvas.Callback(ref,"Eraser",true)
		Canvas.Sudda=true
		Canvas.MC:SetFrameLevel(3)
	end

end

function PaintBoxThingy:ClearAll(ref)
	CLEAR(ref)
end



function PaintBoxThingy:SetColor(ref,r,b,g,a)
	if not a then a=1 end
	Canvases[ref].Canvas.col={r=r,b=b,g=g,a=a}
end

function PaintBoxThingy:GetColor(ref)
	local r,g,b,a
	r = Canvases[ref].Canvas.col.r
	g = Canvases[ref].Canvas.col.g
	b = Canvases[ref].Canvas.col.b
	a = Canvases[ref].Canvas.col.a
	return r,g,b,a
end

function PaintBoxThingy:SetThickness(ref,size)
	Canvases[ref].Canvas.Thickness=size
end

function PaintBoxThingy:SetComm(ref,channel,extra)
	Canvases[ref].Canvas.Channel=channel
	Canvases[ref].Canvas.comextra = extra
end

function PaintBoxThingy:TransferEditor(ref)
	local Canvas=Canvases[ref].Canvas
	if Canvas.Editor then return end
	local prefix = "Edit"..ref
	local msg = "Gief editor "..UnitName("player")
	editwait = true
	if not (Canvas.Insync) then
		RequestResync(ref)
	end
	SendAddonMessage(prefix,msg,Canvas.Channel)
end

function PaintBoxThingy:ForceEditor(ref,state)
	local Canvas = Canvases[ref].Canvas
	Canvas.Editor=state
	Canvas.AP=#Framepool.Anchor[ref]
	Canvas.Callback(ref,"Editor",state)

	if state==false then
		PaintBoxThingy:ContSend(ref,false)
		Canvas.Insync = false
		Canvas.Resync = false
		Canvas.WaitResync = false
		Onemode(Canvas)
	end
end

function PaintBoxThingy:Save(ref,size)
	if size and size<10 then
		return false, "Size to small, must be >=10"
	end
	return CreateString(ref,1,size)
end

function PaintBoxThingy:Load(ref,Data)
	CLEAR(ref)
	local status, err, Type
	Type = type(Data)
	if Type =="table" then
		for i,v in pairs(Data) do
			status ,err =  pcall(Load,ref,v)
			if status == false then
				CLEAR(ref)
				return "Invalid string in index "..i
			end
		end
	elseif Type =="string" then
		--status, err = pcall(Load,ref,Data)
		status, err = pcall(Load,ref,Data)
		if status == false then
			CLEAR(ref)
			return "Invalid string"
		end
	end

end



