

local Origicons = { --Setup Icons
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_1",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_2",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_3",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_4",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_5",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_6",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_7",
	"Interface\\TargetingFrame\\UI-RaidTargetingIcon_8",
}

--Create a "main" frame and a toolbox attatchment and all the buttons.
local editor=CreateFrame("Frame", "WowPaint_Frame",UIParent)
editor:SetWidth(600)
editor:SetHeight(600)
editor:SetBackdrop({bgFile = "Interface/TutorialFrame/TutorialFrameBackground",
	edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",--"Interface/AddOns/Peggle/images/windowBorder",
	tile = true, tileSize = 64, edgeSize = 32,
	insets = { left = 8, right = 8, top = 8, bottom = 8 }
})

editor:Hide()

editor.anchor= CreateFrame("frame","$parentdrag",WowPaint_Frame)
editor.anchor:SetSize(570,30)
editor.anchor:SetPoint("CENTER",UIParent)
editor.anchor:Show()
editor.anchor:SetFrameLevel(9999)

editor:SetPoint("TOPLEFT",editor.anchor,"TOPLEFT",0,0)
editor.anchor:SetMovable(true)
editor.anchor:EnableMouse(true)
editor.anchor:RegisterForDrag("LeftButton")
editor.anchor:SetScript("OnDragStart", function()
	editor.anchor:StartMoving()
end)
editor.anchor:SetScript("OnDragStop", function()
	editor.anchor:StopMovingOrSizing()
end)

local CloseButton = CreateFrame("Button","$parentCloseButton",WowPaint_Frame,"UIPanelCloseButton")
CloseButton:SetPoint("TOPRIGHT")
CloseButton:Show()



local Toolbox = CreateFrame("Frame","$parentToolbox",WowPaint_Frame)
local ikoner = {"Editor","Send","Circle","Square","Line","Pencil","Eraser","Triangle","Bild","Save","Load"}
local path = "Interface/AddOns/WowPaint/Icons/"
Toolbox:SetSize(60,660)
Toolbox:SetPoint("LEFT",WowPaint_Frame,"RIGHT")
Toolbox:SetBackdrop({bgFile = "Interface/TutorialFrame/TutorialFrameBackground",
	edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
	tile = true, tileSize = 64, edgeSize = 32,
	insets = { left = 8, right = 8, top = 8, bottom = 8 }
})
Toolbox:Show()

for n, namn in pairs(ikoner) do
	editor[namn] = CreateFrame("Button","$parent"..namn,Toolbox)
	local knapp=editor[namn]
	knapp:SetSize(32,32)
	knapp:SetPoint("TOP",Toolbox,"TOP",0,n*-60+45)
	knapp:SetNormalTexture(path..namn)
	knapp:SetHighlightTexture(path.."Highlight"..namn,"BLEND")
	knapp:SetDisabledTexture(path.."Disabled"..namn,"BLEND")
	knapp.Toggle = function(self,status)
		--print("Button: "..self:GetName().." is set to status "..tostring(status))
		self.aktiv=status
		if status then
			self:LockHighlight()
		else
			self:UnlockHighlight()
		end
	end
	knapp:Disable()
end
---------Bläh
	local Bild = editor.Bild
	local Editor = editor.Editor
	local Circle = editor.Circle
	local Square = editor.Square
	local Line = editor.Line
	local Pencil = editor.Pencil
	local Eraser = editor.Eraser
	local Triangle = editor.Triangle
	local Send = editor.Send
	local Load = editor.Load
	local Save = editor.Save
-------------------Special för bild
	local Bild = editor.Bild
	Bild:SetNormalTexture(Origicons[1])
	Bild:SetHighlightTexture(Origicons[1],"MOD")
	Bild.id=1
	Bild:RegisterForClicks("RightButtonUp","LeftButtonUp")
----------

	Editor:Enable()
	Editor:SetScript("OnClick", function() PBT:TransferEditor("WowPaint") end)
	Circle:SetScript("OnClick",function() PBT:DrawCircle("WowPaint")end)
	Square:SetScript("OnClick",function() PBT:DrawSquare("WowPaint")end)
	Line:SetScript("OnClick",function() PBT:DrawLine("WowPaint")end)
	Pencil:SetScript("OnClick",function() PBT:Draw("WowPaint")end)
	Eraser:SetScript("OnClick",function() PBT:Eraser("WowPaint")end)
	Triangle:SetScript("OnClick",function() PBT:DrawTriangle("WowPaint")end)
	Save:SetScript("OnClick", function() WowPaintSave = PBT:Save("WowPaint",300) end)
	Load:SetScript("OnClick", function() PBT:Load("WowPaint",WowPaintSave) end)

	Bild:SetScript("OnClick",function(self,button)
		if button == "LeftButton" then
			PBT:PlaceTexture("WowPaint",self.id)
		elseif button == "RightButton" then
			if self.id==8 then
				self.id=1
			else
				self.id = self.id +1
			end
			if self.aktiv then
				PBT:PlaceTexture("WowPaint",self.id) --disable and
				PBT:PlaceTexture("WowPaint",self.id) --enable to change texture
			end
			self:SetNormalTexture(Origicons[self.id])
			self:SetHighlightTexture(Origicons[self.id],"MOD")
		end
	end)

function Send.blink()
	if Send.On then
		Send:UnlockHighlight()
		Send.On=false
	else
		Send:LockHighlight()
		Send.On=true
	end
end

	Send:RegisterForClicks("RightButtonUp","LeftButtonUp")
	Send:SetScript("OnClick",function(self,button)
		if button == "LeftButton" then
			PBT:Send("WowPaint")
		elseif button == "RightButton" then
			if self.aktiv then
				PBT:ContSend("WowPaint",false)
				self:UnlockHighlight()
				if self.Blink then
					self.Blink:Cancel()
					self.Blink=nil
				end
			else
				PBT:ContSend("WowPaint",true)
				self.Blink = C_Timer.NewTicker(1,Send.blink)
			end
		end
	end)

local function Mycallbackfunction(ref,vad,status)
	if vad=="Editor" then
		for _,namn in pairs(ikoner) do
			if namn ~="Editor" then
				if status then
					editor[namn]:Enable()
				else
					editor[namn]:Disable()
				end
			else
				Editor:Toggle(status)
			end
		end
	end
	if vad=="Circle" then
		Circle:Toggle(status)
	elseif vad=="Square" then
		Square:Toggle(status)
	elseif vad=="Line" then
		Line:Toggle(status)
	elseif vad=="Draw" then
		Pencil:Toggle(status)
	elseif vad=="Eraser" then
		Eraser:Toggle(status)
	elseif vad=="Triangle" then
		Triangle:Toggle(status)
	elseif vad=="Texture" then
		Bild:Toggle(status)
	elseif vad=="ContSend" then
		Send.aktiv=status
		if status==false and Send.Blink then
			Send.Blink:Cancel()
			Send.Blink=nil
			Send:UnlockHighlight()
		end
	end
end

local function ColorP()
	local r,g,b = ColorPickerFrame:GetColorRGB()
	local a = OpacitySliderFrame:GetValue()
	PBT:SetColor("WowPaint",r,b,g,a)
end
function Pick()
	ColorPickerFrame.func=ColorP
	ColorPickerFrame.opacityFunc=ColorP
	ColorPickerFrame.hasOpacity=true
	local r,g,b,a = PBT:GetColor("WowPaint")
	ColorPickerFrame.opacity = a
	ColorPickerFrame.previousValues = {r,g,b,a}
	ColorPickerFrame:Show()
end

--Init of the library
PBT = LibStub("PaintBoxThingy-1.0")
PBT:Init("WowPaint",WowPaint_Frame,Mycallbackfunction,{editor.anchor},-20,8,8,-8)
--PBT:Init("WowPaint",WorldMapFrame.ScrollContainer.Child,Mycallbackfunction)--,{WorldMapTitleButton,WorldMapButton})

----Handle who the editor is

local events = {}

function events:GROUP_JOINED(...)
--print("Joined group")
	if UnitIsGroupLeader("player") then
		--print("You are the leader YAY!")
		PBT:ForceEditor("WowPaint",true)
	else
		--print("You are not the leader")
		PBT:ForceEditor("WowPaint",false)
		PBT:ClearAll("WowPaint")
	end
end

function events:GROUP_LEFT(...)
	--print("You left the group")
	PBT:ForceEditor("WowPaint",true)
end

local frame = CreateFrame("frame")
frame:SetScript("OnEvent", function(self, event, ...)
 events[event](self, ...); -- call one of the functions above
end);

for k, v in pairs(events) do
 frame:RegisterEvent(k); -- Register all events for which handlers have been defined
end

if not IsInGroup(LE_PARTY_CATEGORY_HOME) then
	--print("You are not in a group")
	PBT:ForceEditor("WowPaint",true)
else
	--print("You are in a group")
	if UnitIsGroupLeader("player") then
		--print("And you are the leader YAY!")
		PBT:ForceEditor("WowPaint",true)
	end
end


PBT:SetComm("WowPaint","RAID")

SLASH_WOWPAINT1, SLASH_WOWPAINT2 = "/paint", "/wowpaint"

function SlashCmdList.WOWPAINT(msg)
	WowPaint_Frame:Show()
end



